Imports System.Data.OleDb

Public Class Form1
    'Variabili locali per la gestione della paginazione
    Private PaginaCorrente As Integer
    Private dttDati As DataTable
    Private TotalePagine As Integer
    Private RecordAttuale As Integer

    Private Sub BtnCarica_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnCarica.Click
        'connessione
        Dim conDati As OleDbConnection = New OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0; Data Source=c:\Northwind.mdb")
 
        'oggetto per la query
        Dim daDati As New OleDbDataAdapter("select * from customers", conDati)
        Dim dtsDati As New DataSet()

        'Carico il dataset
        daDati.Fill(dtsDati, "customers")

        'Gestione delle pagine
        dttDati = dtsDati.Tables("customers")
        TotalePagine = dttDati.Rows.Count / CType(TxtRecordPerPagina.Text, Integer)
        If (dttDati.Rows.Count Mod CType(TxtRecordPerPagina.Text, Integer)) > 0 Then
            TotalePagine = TotalePagine + 1
        End If
        'Imposto le variabile per la paginazione
        PaginaCorrente = 1
        RecordAttuale = 0
        'Carico i dati
        CaricaDati()
 

    End Sub
    ''' <summary>
    ''' Funzione per il carimento dei dati
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub CaricaDati()


        Dim conta As Integer
        Dim RecordInziale As Integer
        Dim RecordFinale As Integer
        'DataTable temporaneo
        Dim dttTemp As DataTable

        'Record per pagina
        Dim RecordPerPagina As Integer
        'Totale record
        Dim TotaleRecord As Integer

        RecordPerPagina = CType(TxtRecordPerPagina.Text, Integer)
        'rilevo il totale dei record
        TotaleRecord = dttDati.Rows.Count
        'Copio i dati in un dataTable temporaneo
        dttTemp = dttDati.Clone
        'rilevo il record finale
        If PaginaCorrente = TotalePagine Then
            RecordFinale = TotaleRecord
        Else
            RecordFinale = RecordPerPagina * PaginaCorrente
        End If
        'rilevo il recordo iniziale
        RecordInziale = RecordAttuale

        'importo (copio) i record che dovr visualizzare dal range composto dal record iniziale al record finale
        For conta = RecordInziale To RecordFinale - 1
            dttTemp.ImportRow(dttDati.Rows(conta))
            RecordAttuale = RecordAttuale + 1
        Next
        'carico la griglia e visualizzare la posizione
        DtgDati.DataSource = dttTemp
        txtPosizione.Text = "Pagina " & PaginaCorrente.ToString() & "/" & TotalePagine.ToString()
    End Sub

    Private Sub BtnSuccessivo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnSuccessivo.Click
        If TotalePagine = 0 Then
            MessageBox.Show("Impostare la dimensione della pagina e verificare i dati")
            Return
        End If
        PaginaCorrente += 1
        If PaginaCorrente > TotalePagine Then
            PaginaCorrente = TotalePagine
            If RecordAttuale = dttDati.Rows.Count Then
                Return
            End If
        End If
        CaricaDati()

    End Sub

    Private Sub btnPrecedente_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPrecedente.Click
        PaginaCorrente -= 1
        If PaginaCorrente < 1 Then
            PaginaCorrente = 1
            Return
        End If
        RecordAttuale = CType(TxtRecordPerPagina.Text, Integer) * (PaginaCorrente - 1)
        CaricaDati()
    End Sub

    Private Sub btnPrimo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPrimo.Click
        PaginaCorrente = 1
        RecordAttuale = 0
        CaricaDati()
    End Sub

    Private Sub btnUltimo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnUltimo.Click
        PaginaCorrente = TotalePagine
        RecordAttuale = dttDati.Rows.Count - 1
        CaricaDati()

    End Sub

   
End Class
